## proxmox-backup-client-4.1.2.tar.xz

=== pathpatterns/Makefile ===
include /usr/share/dpkg/pkg-info.mk

SRCPACKAGE=rust-pathpatterns
PACKAGE=lib$(SRCPACKAGE)-dev
ARCH:=$(shell dpkg-architecture -qDEB_BUILD_ARCH)

DEB=$(PACKAGE)_$(DEB_VERSION)_$(ARCH).deb
DSC=$(SRCPACKAGE)_$(DEB_VERSION)_$(ARCH).deb

.PHONY: all
all: check

.PHONY: check
check:
	cargo test

.PHONY: dinstall
dinstall: deb
	sudo -k dpkg -i build/librust-*.deb

build:
	rm -rf build
	rm debian/control
	mkdir build
	debcargo package \
	    --config "$(PWD)/debian/debcargo.toml" \
	    --changelog-ready \
	    --no-overlay-write-back \
	    --directory "$(PWD)/build/pathpatterns" \
	    "pathpatterns" \
	    "$$(dpkg-parsechangelog -l "debian/changelog" -SVersion | sed -e 's/-.*//')"
	echo system >build/rust-toolchain
	rm -f build/pathpatterns/Cargo.lock
	find build/pathpatterns/debian -name '*.hint' -delete
	cp build/pathpatterns/debian/control debian/control

.PHONY: deb
deb:
	rm -rf build
	$(MAKE) build/$(DEB)
build/$(DEB): build
	(cd build/pathpatterns && CARGO=/usr/bin/cargo RUSTC=/usr/bin/rustc dpkg-buildpackage -b -uc -us)
	lintian build/*.deb

.PHONY: dsc
dsc:
	rm -rf build
	$(MAKE) build/$(DSC)
build/$(DSC): build
	(cd build/pathpatterns && CARGO=/usr/bin/cargo RUSTC=/usr/bin/rustc dpkg-buildpackage -S -uc -us)
	lintian build/*.dsc

.PHONY: clean
clean:
	rm -rf build *.deb *.dsc *.buildinfo *.changes *.orig.tar.gz
	cargo clean

.PHONY: upload
upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
upload: build/$(DEB)
	# check if working directory is clean
	git diff --exit-code --stat && git diff --exit-code --stat --staged
	tar -C build -cf - $(DEB) | ssh -X repoman@repo.proxmox.com upload --product devel --dist $(DEB_DISTRIBUTION)

=== proxmox-backup/Makefile ===
include /usr/share/dpkg/default.mk
include /usr/share/rustc/architecture.mk
include defines.mk

PACKAGE := proxmox-backup
ARCH := $(DEB_BUILD_ARCH)
export DEB_HOST_RUST_TYPE

SUBDIRS := etc www docs templates

# Binaries usable by users
USR_BIN := \
	proxmox-backup-client 	\
	proxmox-file-restore	\
	pxar			\
	proxmox-tape		\
	pmtx			\
	pmt

# Binaries usable by admins
USR_SBIN := \
	proxmox-backup-manager \
	proxmox-backup-debug

# Binaries for services:
SERVICE_BIN := \
	proxmox-backup-api \
	proxmox-backup-banner \
	proxmox-backup-proxy \
	proxmox-daily-update

# Single file restore daemon
RESTORE_BIN := \
	proxmox-restore-daemon

SUBCRATES != cargo metadata --no-deps --format-version=1 \
	| jq -r .workspace_members'[]' \
	| grep "$$PWD/" \
	| sed -e "s!.*$$PWD/!!g" -e 's/\#.*$$//g' -e 's/)$$//g'

# sync with debian/rules!
STATIC_TARGET_DIR := target/static-build
ifeq ($(BUILD_MODE), release)
CARGO_BUILD_ARGS += --release --target $(DEB_HOST_RUST_TYPE)
CARGO_STATIC_CONFIG ?= --config debian/cargo_home/config.static.toml
CARGO_STATIC_BUILD_ARGS += $(CARGO_STATIC_CONFIG) --release --target $(DEB_HOST_RUST_TYPE) --target-dir $(STATIC_TARGET_DIR)
COMPILEDIR := target/$(DEB_HOST_RUST_TYPE)/release
STATIC_COMPILEDIR := $(STATIC_TARGET_DIR)/$(DEB_HOST_RUST_TYPE)/release
else
CARGO_BUILD_ARGS += --target $(DEB_HOST_RUST_TYPE)
CARGO_STATIC_BUILD_ARGS += --target $(DEB_HOST_RUST_TYPE) --target-dir $(STATIC_TARGET_DIR)
COMPILEDIR := target/$(DEB_HOST_RUST_TYPE)/debug
STATIC_COMPILEDIR := $(STATIC_TARGET_DIR)/$(DEB_HOST_RUST_TYPE)/debug
endif

STATIC_RUSTC_FLAGS := -C target-feature=+crt-static -L $(STATIC_COMPILEDIR)/deps-stubs/
# end sync with debian/rules

ifeq ($(valgrind), yes)
CARGO_BUILD_ARGS += --features valgrind
endif

CARGO ?= cargo

COMPILED_BINS := \
	$(addprefix $(COMPILEDIR)/,$(USR_BIN) $(USR_SBIN) $(SERVICE_BIN) $(RESTORE_BIN))

STATIC_BINS := \
	$(addprefix $(STATIC_COMPILEDIR)/,proxmox-backup-client-static pxar-static)

export DEB_VERSION DEB_VERSION_UPSTREAM

SERVER_DEB=$(PACKAGE)-server_$(DEB_VERSION)_$(ARCH).deb
SERVER_DBG_DEB=$(PACKAGE)-server-dbgsym_$(DEB_VERSION)_$(ARCH).deb
CLIENT_DEB=$(PACKAGE)-client_$(DEB_VERSION)_$(ARCH).deb
CLIENT_DBG_DEB=$(PACKAGE)-client-dbgsym_$(DEB_VERSION)_$(ARCH).deb
RESTORE_DEB=proxmox-backup-file-restore_$(DEB_VERSION)_$(ARCH).deb
RESTORE_DBG_DEB=proxmox-backup-file-restore-dbgsym_$(DEB_VERSION)_$(ARCH).deb
STATIC_CLIENT_DEB=$(PACKAGE)-client-static_$(DEB_VERSION)_$(ARCH).deb
STATIC_CLIENT_DBG_DEB=$(PACKAGE)-client-static-dbgsym_$(DEB_VERSION)_$(ARCH).deb
DOC_DEB=$(PACKAGE)-docs_$(DEB_VERSION)_all.deb

DEBS=$(SERVER_DEB) $(SERVER_DBG_DEB) $(CLIENT_DEB) $(CLIENT_DBG_DEB) \
     $(RESTORE_DEB) $(RESTORE_DBG_DEB) $(STATIC_CLIENT_DEB) $(STATIC_CLIENT_DBG_DEB)

DSC = rust-$(PACKAGE)_$(DEB_VERSION).dsc

DESTDIR=

tests ?= --workspace

all: proxmox-backup-client-static $(SUBDIRS)

.PHONY: $(SUBDIRS)
$(SUBDIRS):
	$(MAKE) -C $@

test:
	#cargo test test_broadcast_future
	#cargo test $(CARGO_BUILD_ARGS)
	$(CARGO) test $(tests) $(CARGO_BUILD_ARGS)

doc:
	$(CARGO) doc --workspace --no-deps $(CARGO_BUILD_ARGS)

# always re-create this dir
.PHONY: build
build:
	rm -rf build
	mkdir build
	git rev-parse HEAD > build/.repoid
	cp -a debian \
	  Cargo.toml src \
	  $(SUBCRATES) \
	  docs etc examples tests www zsh-completions templates \
	  defines.mk Makefile \
	  ./build/
	rm -f build/Cargo.lock
	find build/debian -name "*.hint" -delete
	$(foreach i,$(SUBDIRS), \
	    $(MAKE) -C build/$(i) clean ;)


.PHONY: proxmox-backup-docs
$(DOC_DEB) $(DEBS): proxmox-backup-docs
proxmox-backup-docs: build
	cd build; dpkg-buildpackage -b -us -uc --no-pre-clean
	lintian $(DOC_DEB)

.PHONY: deb dsc deb-nodoc deb-nostrip
deb-nodoc: build
	cd build; dpkg-buildpackage -b -us -uc --no-pre-clean --build-profiles=nodoc
	lintian $(DEBS)

deb-nostrip: build
	cd build; DEB_BUILD_OPTIONS=nostrip dpkg-buildpackage -b -us -uc
	lintian $(DEBS) $(DOC_DEB)

$(DEBS): deb
deb: build
	cd build; dpkg-buildpackage -b -us -uc
	lintian $(DEBS) $(DOC_DEB)

.PHONY: dsc
dsc:
	rm -rf $(DSC) build/
	$(MAKE) $(DSC)
	lintian $(DSC)

$(DSC): build
	cd build; dpkg-buildpackage -S -us -uc -d

sbuild: $(DSC)
	sbuild $<

.PHONY: clean distclean deb clean
distclean: clean
clean: clean-deb
	$(foreach i,$(SUBDIRS), \
	    $(MAKE) -C $(i) clean ;)
	$(CARGO) clean

# allows one to avoid running cargo clean when one just wants to tidy up after a package build
clean-deb:
	rm -rf build/
	rm -f *.deb *.dsc *.tar.* *.buildinfo *.build *.changes

.PHONY: dinstall
dinstall: $(SERVER_DEB) $(SERVER_DBG_DEB) $(CLIENT_DEB) $(CLIENT_DBG_DEB)
	dpkg -i $^

# make sure we build binaries before docs
docs: $(COMPILEDIR)/dump-catalog-shell-cli $(COMPILEDIR)/docgen

.PHONY: cargo-build
cargo-build:
	$(MAKE) $(COMPILED_BINS)

$(COMPILED_BINS) $(COMPILEDIR)/dump-catalog-shell-cli $(COMPILEDIR)/docgen &:
	$(CARGO) build $(CARGO_BUILD_ARGS) \
	    --package proxmox-backup-banner \
	    --bin proxmox-backup-banner \
	    --package proxmox-backup-client \
	    --bin proxmox-backup-client \
	    --bin dump-catalog-shell-cli \
	    --bin proxmox-backup-debug \
	    --package proxmox-file-restore \
	    --bin proxmox-file-restore \
	    --package pxar-bin \
	    --bin pxar \
	    --package pbs-tape \
	    --bin pmt \
	    --bin pmtx \
	    --package proxmox-restore-daemon \
	    --bin proxmox-restore-daemon \
	    --package proxmox-backup \
	    --bin docgen \
	    --bin pbs3to4 \
	    --bin proxmox-backup-api \
	    --bin proxmox-backup-manager \
	    --bin proxmox-backup-proxy \
	    --bin proxmox-daily-update \
	    --bin proxmox-file-restore \
	    --bin proxmox-tape \
	    --bin sg-tape-cmd
	touch "$@"

.PHONY: proxmox-backup-client-static
proxmox-backup-client-static:
	$(MAKE) $(STATIC_BINS)

$(STATIC_BINS) &:
	mkdir -p $(STATIC_COMPILEDIR)/deps-stubs/ && \
          echo '!<arch>' > $(STATIC_COMPILEDIR)/deps-stubs/libsystemd.a # workaround for to greedy linkage and proxmox-systemd
	OPENSSL_STATIC=1 \
	RUSTFLAGS="$(STATIC_RUSTC_FLAGS)" \
	$(CARGO) build $(CARGO_STATIC_BUILD_ARGS) --package pxar-bin --bin pxar
	OPENSSL_STATIC=1 \
	RUSTFLAGS="$(STATIC_RUSTC_FLAGS)" \
	$(CARGO) build $(CARGO_STATIC_BUILD_ARGS) --package proxmox-backup-client --bin proxmox-backup-client

.PHONY: lint
lint:
	cargo clippy -- -A clippy::all -D clippy::correctness

install: $(COMPILED_BINS) $(STATIC_BINS)
	install -dm755 $(DESTDIR)$(BINDIR)
	install -dm755 $(DESTDIR)$(ZSH_COMPL_DEST)
	$(foreach i,$(USR_BIN), \
	    install -m755 $(COMPILEDIR)/$(i) $(DESTDIR)$(BINDIR)/ ; \
	    install -m644 zsh-completions/_$(i) $(DESTDIR)$(ZSH_COMPL_DEST)/ ;)
	install -dm755 $(DESTDIR)$(SBINDIR)
	$(foreach i,$(USR_SBIN), \
	    install -m755 $(COMPILEDIR)/$(i) $(DESTDIR)$(SBINDIR)/ ; \
	    install -m644 zsh-completions/_$(i) $(DESTDIR)$(ZSH_COMPL_DEST)/ ;)
	install -m755 $(COMPILEDIR)/pbs3to4 $(DESTDIR)$(SBINDIR)/
	install -dm755 $(DESTDIR)$(LIBEXECDIR)/proxmox-backup
	install -dm755 $(DESTDIR)$(LIBEXECDIR)/proxmox-backup/file-restore
	$(foreach i,$(RESTORE_BIN), \
	    install -m755 $(COMPILEDIR)/$(i) $(DESTDIR)$(LIBEXECDIR)/proxmox-backup/file-restore/ ;)
	# install sg-tape-cmd as setuid binary
	install -m4755 -o root -g root $(COMPILEDIR)/sg-tape-cmd $(DESTDIR)$(LIBEXECDIR)/proxmox-backup/sg-tape-cmd
	$(foreach i,$(SERVICE_BIN), \
	    install -m755 $(COMPILEDIR)/$(i) $(DESTDIR)$(LIBEXECDIR)/proxmox-backup/ ;)
	install -m755 $(STATIC_COMPILEDIR)/proxmox-backup-client $(DESTDIR)$(BINDIR)/proxmox-backup-client-static
	install -m755 $(STATIC_COMPILEDIR)/pxar $(DESTDIR)$(BINDIR)/pxar-static
	$(MAKE) -C www install
	$(MAKE) -C docs install
	$(MAKE) -C templates install

.PHONY: upload
upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
upload: $(SERVER_DEB) $(CLIENT_DEB) $(RESTORE_DEB) $(DOC_DEB) $(STATIC_CLIENT_DEB)
	# check if working directory is clean
	git diff --exit-code --stat && git diff --exit-code --stat --staged
	tar cf - $(SERVER_DEB) $(SERVER_DBG_DEB) $(DOC_DEB) $(CLIENT_DEB) $(CLIENT_DBG_DEB) \
	  | ssh -X repoman@repo.proxmox.com upload --product pbs --dist $(UPLOAD_DIST) --arch $(DEB_HOST_ARCH)
	tar cf - $(CLIENT_DEB) $(CLIENT_DBG_DEB) | ssh -X repoman@repo.proxmox.com upload --product "pve,pmg,pbs-client" --dist $(UPLOAD_DIST) --arch $(DEB_HOST_ARCH)
	tar cf - $(STATIC_CLIENT_DEB) $(STATIC_CLIENT_DBG_DEB) | ssh -X repoman@repo.proxmox.com upload --product "pbs-client" --dist $(UPLOAD_DIST) --arch $(DEB_HOST_ARCH)
	tar cf - $(RESTORE_DEB) $(RESTORE_DBG_DEB) | ssh -X repoman@repo.proxmox.com upload --product "pve" --dist $(UPLOAD_DIST) --arch $(DEB_HOST_ARCH)

=== proxmox-fuse/Makefile ===
include /usr/share/dpkg/pkg-info.mk

SRCPACKAGE=rust-proxmox-fuse
PACKAGE=lib$(SRCPACKAGE)-dev
ARCH:=$(shell dpkg-architecture -qDEB_BUILD_ARCH)

DEB=$(PACKAGE)_$(DEB_VERSION)_$(ARCH).deb
DSC=$(SRCPACKAGE)_$(DEB_VERSION)_$(ARCH).deb

.PHONY: all
all: check

.PHONY: check
check:
	cargo test --all-features

.PHONY: dinstall
dinstall: deb
	sudo -k dpkg -i build/librust-*.deb

build:
	rm -rf build
	rm debian/control
	mkdir build
	debcargo package \
	    --config "$(PWD)/debian/debcargo.toml" \
	    --changelog-ready \
	    --no-overlay-write-back \
	    --directory "$(PWD)/build/proxmox-fuse" \
	    "proxmox-fuse" \
	    "$$(dpkg-parsechangelog -l "debian/changelog" -SVersion | sed -e 's/-.*//')"
	echo system >build/rust-toolchain
	rm -f build/proxmox-fuse/Cargo.lock
	find build/proxmox-fuse/debian -name '*.hint' -delete
	cp build/proxmox-fuse/debian/control debian/control

.PHONY: deb
deb:
	rm -rf build
	$(MAKE) build/$(DEB)
build/$(DEB): build
	(cd build/proxmox-fuse && CARGO=/usr/bin/cargo RUSTC=/usr/bin/rustc dpkg-buildpackage -b -uc -us)
	lintian build/*.deb

.PHONY: dsc
dsc:
	rm -rf build
	$(MAKE) build/$(DSC)
build/$(DSC): build
	(cd build/proxmox-fuse && CARGO=/usr/bin/cargo RUSTC=/usr/bin/rustc dpkg-buildpackage -S -uc -us)
	lintian build/*.dsc

.PHONY: clean
clean:
	rm -rf build
	cargo clean

.PHONY: upload
upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
upload: build/$(DEB)
	cd build; \
	    dcmd --deb rust-proxmox-fuse_*.changes \
	    | grep -v '.changes$$' \
	    | tar -cf- -T- \
	    | ssh -X repoman@repo.proxmox.com upload --product devel --dist $(UPLOAD_DIST)

=== proxmox/Makefile ===
# Shortcut for common operations:

# see proxmox-backup if we ever want to support other prefixes
CRATES != echo pbs-*/Cargo.toml proxmox-*/Cargo.toml | sed -e 's|/Cargo.toml||g'

# By default we just run checks:
.PHONY: all
all: check

.PHONY: deb
deb: $(foreach c,$(CRATES), $c-deb)
	echo $(foreach c,$(CRATES), $c-deb)
	lintian build/*.deb

.PHONY: dsc
dsc: $(foreach c,$(CRATES), $c-dsc)
	echo $(foreach c,$(CRATES), $c-dsc)
	lintian build/*.dsc

.PHONY: autopkgtest
autopkgtest: $(foreach c,$(CRATES), $c-autopkgtest)

.PHONY: dinstall
dinstall:
	$(MAKE) clean
	$(MAKE) deb
	sudo -k dpkg -i build/librust-*.deb

%-deb:
	./build.sh $*
	touch $@

proxmox-oci-deb:
	TEST_CMD="fakeroot cargo test --all-features --all-targets --release" ./build.sh proxmox-oci
	touch $@

%-dsc:
	BUILDCMD='dpkg-buildpackage -S -us -uc -d' NOTEST=1 ./build.sh $*
	touch $@

%-autopkgtest:
	autopkgtest build/$* build/*.deb -- null
	touch $@

.PHONY: list-packages
list-packages:
	@for p in $(CRATES); do \
		echo "librust-$$p-dev"; \
	done

.PHONY: check
check:
	cargo test

# Run the api-test server, serving the api-test/www/ subdir as 'www' dir over
# http:
.PHONY: apitest
apitest:
	cargo run -p api-test -- api-test/www/

# Prints a diff between the current code and the one rustfmt would produce
.PHONY: fmt
fmt:
	cargo +nightly fmt -- --check

# Doc without dependencies
.PHONY: doc
doc:
	cargo doc --no-deps

.PHONY: clean
clean:
	cargo clean
	rm -rf build/
	rm -f -- *-deb *-dsc *-autopkgtest *.build *.buildinfo *.changes

.PHONY: update
update:
	cargo update

%-upload: %-deb
	cd build; \
	    dcmd --deb rust-$*_*.changes \
	    | grep -v '.changes$$' \
	    | tar -cf "$@.tar" -T-; \
	    cat "$@.tar" | ssh -X repoman@repo.proxmox.com upload --product devel --dist trixie

%-install:
	rm -rf build/install/$*
	mkdir -p build/install/$*
	BUILDDIR=build/install/$* BUILDCMD=/usr/bin/true NOCONTROL=1 ./build.sh "$*" || true
	version="$$(dpkg-parsechangelog -l $*/debian/changelog -SVersion | sed -e 's/-.*//')"; \
	  install -m755 -Dd "$(DESTDIR)/usr/share/cargo/registry/$*-$${version}"; \
	  rm -rf "$(DESTDIR)/usr/share/cargo/registry/$*-$${version}"; \
	  mv "build/install/$*/$*" \
	    "$(DESTDIR)/usr/share/cargo/registry/$*-$${version}"; \
	  mv "$(DESTDIR)/usr/share/cargo/registry/$*-$${version}/debian/cargo-checksum.json" \
	    "$(DESTDIR)/usr/share/cargo/registry/$*-$${version}/.cargo-checksum.json"; \
	  rm -rf "$(DESTDIR)/usr/share/cargo/registry/$*-$${version}/debian" \

.PHONY: install
install: $(foreach c,$(CRATES), $c-install)

%-install-overlay: %-install
	version="$$(dpkg-parsechangelog -l $*/debian/changelog -SVersion | sed -e 's/-.*//')"; \
	  setfattr -n trusted.overlay.opaque -v y \
	    "$(DESTDIR)/usr/share/cargo/registry/$*-$${version}"
	install -m755 -Dd $(DESTDIR)/usr/lib/extension-release.d
	echo 'ID=_any' >$(DESTDIR)/usr/lib/extension-release.d/extension-release.$*

.PHONY: install-overlay
install-overlay: $(foreach c,$(CRATES), $c-install-overlay)

# To make sure a sysext *replaces* a crate, rather than "merging" with it, we
# need to be able to set the 'trusted.overlay.opaque' xattr. Since we cannot do
# this as a user, we utilize `fakeroot` which keeps track of this for us, and
# turn the final directory into an 'erofs' file system image.
#
# The reason is that if a crate gets changed like this:
#
#     old:
#         src/foo.rs
#     new:
#         src/foo/mod.rs
#
# if its /usr/share/cargo/registry/$crate-$version directory was not marked as
# "opaque", the merged file system would end up with both
#
#         src/foo.rs
#         src/foo/mod.rs
#
# together.
#
# See https://docs.kernel.org/filesystems/overlayfs.html
%-sysext:
	fakeroot $(MAKE) $*-sysext-do
%-sysext-do:
	rm -f extensions/$*.raw
	rm -rf build/sysext/$*
	rm -rf build/install/$*
	$(MAKE) DESTDIR=build/sysext/$* $*-install-overlay
	mkdir -p extensions
	mkfs.erofs extensions/$*.raw build/sysext/$*

sysext:
	fakeroot $(MAKE) sysext-do
sysext-do:
	rm -f extensions/proxmox-workspace.raw
	[ -n "$(NOCLEAN)" ] || rm -rf build/sysext/workspace
	$(MAKE) DESTDIR=build/sysext/workspace $(foreach c,$(CRATES), $c-install)
	install -m755 -Dd build/sysext/workspace/usr/lib/extension-release.d
	echo 'ID=_any' >build/sysext/workspace/usr/lib/extension-release.d/extension-release.proxmox-workspace
	mkdir -p extensions
	mkfs.erofs extensions/proxmox-workspace.raw build/sysext/workspace

=== pxar/Makefile ===
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

SRCPACKAGE=rust-pxar
PACKAGE=lib$(SRCPACKAGE)-dev
ARCH := $(DEB_BUILD_ARCH)

DEB=$(PACKAGE)_$(DEB_VERSION)_$(ARCH).deb
DSC=$(SRCPACKAGE)_$(DEB_VERSION)_$(ARCH).deb

.PHONY: all
all: check

.PHONY: check
check:
	cargo test --all-features

.PHONY: dinstall
dinstall: deb
	sudo -k dpkg -i build/librust-*.deb

build:
	rm -rf build
	rm -f debian/control
	mkdir build
	debcargo package \
	    --config "$(PWD)/debian/debcargo.toml" \
	    --changelog-ready \
	    --no-overlay-write-back \
	    --directory "$(PWD)/build/pxar" \
	    "pxar" \
	    "$$(dpkg-parsechangelog -l "debian/changelog" -SVersion | sed -e 's/-.*//')"
	echo system >build/rust-toolchain
	rm -f build/pxar/Cargo.lock
	find build/pxar/debian -name '*.hint' -delete
	cp build/pxar/debian/control debian/control

.PHONY: deb
deb:
	rm -rf build
	$(MAKE) build/$(DEB)
build/$(DEB): build
	(cd build/pxar && CARGO=/usr/bin/cargo RUSTC=/usr/bin/rustc dpkg-buildpackage -b -uc -us)
	lintian build/*.deb

.PHONY: dsc
dsc:
	rm -rf build
	$(MAKE) build/$(DSC)
build/$(DSC): build
	(cd build/pxar && CARGO=/usr/bin/cargo RUSTC=/usr/bin/rustc dpkg-buildpackage -S -uc -us)
	lintian build/*.dsc

.PHONY: clean
clean:
	rm -rf build *.deb *.buildinfo *.changes *.orig.tar.gz
	cargo clean

.PHONY: upload
upload: UPLOAD_DIST ?= $(DEB_DISTRIBUTION)
upload: build/$(DEB)
	cd build; \
	    dcmd --deb rust-pxar_*.changes \
	    | grep -v '.changes$$' \
	    | tar -cf- -T- \
	    | ssh -X repoman@repo.proxmox.com upload --product devel --dist $(UPLOAD_DIST)

=== proxmox-backup/docs/Makefile ===
include ../defines.mk

GENERATED_SYNOPSIS := 						\
	proxmox-backup-client/catalog-shell-synopsis.rst 	\
	proxmox-backup-client/synopsis.rst			\
	pxar/synopsis.rst					\

MAN1_PAGES := 				\
	pbs3to4.1			\
	pmt.1				\
	pmtx.1				\
	proxmox-backup-client.1		\
	proxmox-backup-debug.1		\
	proxmox-backup-manager.1	\
	proxmox-backup-proxy.1		\
	proxmox-file-restore.1		\
	proxmox-tape.1			\
	pxar.1				\

# FIXME: prefix all man pages that are not directly relating to an existing executable with
# `proxmox-backup.`, like the newer added proxmox-backup.node.cfg but add backwards compatible
# symlinks, e.g. with a "5pbs" man page "suffix section".
MAN5_PAGES :=				\
	acl.cfg.5			\
	datastore.cfg.5			\
	domains.cfg.5			\
	media-pool.cfg.5		\
	proxmox-backup.node.cfg.5	\
	notifications-priv.cfg.5	\
	notifications.cfg.5		\
	remote.cfg.5			\
	sync.cfg.5			\
	tape-job.cfg.5			\
	tape.cfg.5			\
	user.cfg.5			\
	verification.cfg.5		\
	prune.cfg.5				\

PRUNE_SIMULATOR_FILES := 					\
	prune-simulator/index.html				\
	prune-simulator/clear-trigger.png			\
	prune-simulator/documentation.html			\
	prune-simulator/prune-simulator.js			\

PRUNE_SIMULATOR_JS_SOURCE :=						\
	/usr/share/javascript/proxmox-widget-toolkit-dev/Toolkit.js	\
	prune-simulator/prune-simulator_source.js

LTO_BARCODE_JS_SOURCE :=						\
	/usr/share/javascript/proxmox-widget-toolkit-dev/Toolkit.js	\
	lto-barcode/code39.js						\
	lto-barcode/prefix-field.js					\
	lto-barcode/label-style.js					\
	lto-barcode/tape-type.js					\
	lto-barcode/paper-size.js					\
	lto-barcode/page-layout.js					\
	lto-barcode/page-calibration.js					\
	lto-barcode/label-list.js					\
	lto-barcode/label-setup.js					\
	lto-barcode/lto-barcode.js

LTO_BARCODE_FILES :=						\
	lto-barcode/index.html					\
	lto-barcode/lto-barcode-generator.js

API_VIEWER_SOURCES=				\
	api-viewer/index.html			\
	api-viewer/apidoc.js

API_VIEWER_FILES :=							\
	api-viewer/apidata.js						\
	/usr/share/javascript/proxmox-widget-toolkit-dev/APIViewer.js	\

# Sphinx documentation setup
SPHINXOPTS    = -E
SPHINXBUILD   = sphinx-build
BUILDDIR      = output

ifeq ($(BUILD_MODE), release)
COMPILEDIR := ../target/$(DEB_HOST_RUST_TYPE)/release
SPHINXOPTS    += -t release
else
COMPILEDIR := ../target/$(DEB_HOST_RUST_TYPE)/debug
SPHINXOPTS    += -t devbuild
endif

# Sphinx internal variables.
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(SPHINXOPTS) .

all: ${MAN1_PAGES} ${MAN5_PAGES}

config/%/config.rst: ${COMPILEDIR}/docgen
	${COMPILEDIR}/docgen $*.cfg >$@

config/acl/roles.rst: ${COMPILEDIR}/docgen
	${COMPILEDIR}/docgen "config::acl::Role" >$@

%/synopsis.rst: ${COMPILEDIR}/%
	$< printdoc > $@

proxmox-backup-client/catalog-shell-synopsis.rst: ${COMPILEDIR}/dump-catalog-shell-cli
	${COMPILEDIR}/dump-catalog-shell-cli > proxmox-backup-client/catalog-shell-synopsis.rst

${MAN1_PAGES} ${MAN5_PAGES}: man-pages

.PHONY: man-pages
man-pages: ${GENERATED_SYNOPSIS}
	${SPHINXBUILD} ${SPHINXOPTS} -b man ./ ${BUILDDIR}/man

.PHONY: onlinehelpinfo
onlinehelpinfo:
	@echo "Generating OnlineHelpInfo.js..."
	$(SPHINXBUILD) -b proxmox-scanrefs -Q $(ALLSPHINXOPTS) $(BUILDDIR)/scanrefs
	@echo "Build finished. OnlineHelpInfo.js is in $(BUILDDIR)/scanrefs."

api-viewer/apidata.js: ${COMPILEDIR}/docgen
	${COMPILEDIR}/docgen apidata.js >$@

api-viewer/apidoc.js: ${API_VIEWER_FILES}
	cat ${API_VIEWER_FILES} >$@.tmp
	mv $@.tmp $@

prune-simulator/prune-simulator.js: ${PRUNE_SIMULATOR_JS_SOURCE}
	cat ${PRUNE_SIMULATOR_JS_SOURCE} >$@.tmp
	mv $@.tmp $@

lto-barcode/lto-barcode-generator.js: ${LTO_BARCODE_JS_SOURCE}
	cat ${LTO_BARCODE_JS_SOURCE} >$@.tmp
	mv $@.tmp $@

.PHONY: html
html: ${GENERATED_SYNOPSIS} images/proxmox-logo.svg _static/custom.css conf.py ${PRUNE_SIMULATOR_FILES} ${LTO_BARCODE_FILES} ${API_VIEWER_SOURCES}
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	install -m 0644 _static/custom.js _static/custom.css images/proxmox-logo.svg $(BUILDDIR)/html/_static/
	install -dm 0755 $(BUILDDIR)/html/prune-simulator
	install -m 0644 ${PRUNE_SIMULATOR_FILES} $(BUILDDIR)/html/prune-simulator
	install -dm 0755 $(BUILDDIR)/html/lto-barcode
	install -m 0644 ${LTO_BARCODE_FILES} $(BUILDDIR)/html/lto-barcode
	install -dm 0755 $(BUILDDIR)/html/api-viewer
	install -m 0644 ${API_VIEWER_SOURCES} $(BUILDDIR)/html/api-viewer
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: latexpdf
latexpdf: ${GENERATED_SYNOPSIS}
	@echo "Requires python3-sphinx, texlive-xetex, xindy and texlive-fonts-extra"
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through xelatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "xelatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: epub3
epub3: ${GENERATED_SYNOPSIS}
	$(SPHINXBUILD) -b epub3 $(ALLSPHINXOPTS) $(BUILDDIR)/epub3
	@echo
	@echo "Build finished. The epub3 file is in $(BUILDDIR)/epub3."

clean:
	rm -r -f *~ *.1 ${BUILDDIR} ${GENERATED_SYNOPSIS} api-viewer/apidata.js
	rm -f api-viewer/apidoc.js lto-barcode/lto-barcode-generator.js prune-simulator/prune-simulator.js

install_manual_pages: man-pages
	install -dm755 $(DESTDIR)$(MAN1DIR)
	for i in ${MAN1_PAGES}; do install -m755 ${BUILDDIR}/man/$$i $(DESTDIR)$(MAN1DIR)/ ; done
	install -dm755 $(DESTDIR)$(MAN5DIR)
	for i in ${MAN5_PAGES}; do install -m755 ${BUILDDIR}/man/$$i $(DESTDIR)$(MAN5DIR)/ ; done

install_html: html
	install -dm755 $(DESTDIR)$(DOCDIR)
	rsync -a ${BUILDDIR}/html $(DESTDIR)$(DOCDIR)

install_pdf: latexpdf
	install -dm755 $(DESTDIR)$(DOCDIR)
	install -m 0644 output/latex/ProxmoxBackup.pdf $(DESTDIR)$(DOCDIR)/proxmox-backup.pdf

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)

install: install_manual_pages

else

install: install_manual_pages install_html install_pdf

endif

=== proxmox-backup/etc/Makefile ===
include ../defines.mk

UNITS := \
	pbs-network-config-commit.service \
	proxmox-backup-daily-update.timer \
	removable-device-attach@.service

DYNAMIC_UNITS := \
	proxmox-backup-banner.service \
	proxmox-backup-daily-update.service \
	proxmox-backup.service \
	proxmox-backup-proxy.service

all: $(UNITS) $(DYNAMIC_UNITS) pbs-enterprise.sources

clean:
	rm -f $(DYNAMIC_UNITS)

.SUFFIXES: .service.in .service
.service.in.service:
	sed \
	    -e 's!%LIBEXECDIR%!$(LIBEXECDIR)!g' \
	    -e 's!%PROXY_USER%!$(PROXY_USER)!g' \
	    $< >$@.tmp
	mv $@.tmp $@

=== proxmox-backup/templates/Makefile ===
include ../defines.mk

NOTIFICATION_TEMPLATES=						\
	default/acme-err-body.txt.hbs			\
	default/acme-err-subject.txt.hbs		\
	default/gc-err-body.txt.hbs				\
	default/gc-ok-body.txt.hbs				\
	default/gc-err-subject.txt.hbs			\
	default/gc-ok-subject.txt.hbs			\
	default/package-updates-body.txt.hbs	\
	default/package-updates-subject.txt.hbs	\
	default/prune-err-body.txt.hbs			\
	default/prune-ok-body.txt.hbs			\
	default/prune-err-subject.txt.hbs		\
	default/prune-ok-subject.txt.hbs		\
	default/sync-err-body.txt.hbs			\
	default/sync-ok-body.txt.hbs			\
	default/sync-err-subject.txt.hbs		\
	default/sync-ok-subject.txt.hbs			\
	default/tape-backup-err-body.txt.hbs	\
	default/tape-backup-err-subject.txt.hbs	\
	default/tape-backup-ok-body.txt.hbs		\
	default/tape-backup-ok-subject.txt.hbs	\
	default/tape-load-body.txt.hbs			\
	default/tape-load-subject.txt.hbs		\
	default/test-body.txt.hbs				\
	default/test-subject.txt.hbs			\
	default/verify-err-body.txt.hbs			\
	default/verify-ok-body.txt.hbs			\
	default/verify-err-subject.txt.hbs		\
	default/verify-ok-subject.txt.hbs		\

all:

clean:

install:
	install -dm755 $(DESTDIR)$(DATAROOTDIR)/proxmox-backup/templates/default
	$(foreach i,$(NOTIFICATION_TEMPLATES), \
	    install -m644 $(i) $(DESTDIR)$(DATAROOTDIR)/proxmox-backup/templates/$(i) ;)

=== proxmox/pve-api-types/Makefile ===
OUTPUT_DIR := src/generated

GENERATOR_SOURCES != find generator-lib

all: $(OUTPUT_DIR)/code.rs $(OUTPUT_DIR)/types.rs

pve-api.json: dump-api.pl generator-lib/ApiDump.pm
	perl dump-api.pl >$@.tmp
	mv $@.tmp $@

$(OUTPUT_DIR)/code.rs $(OUTPUT_DIR)/types.rs &: generate.pl $(GENERATOR_SOURCES)
	rm -rf $(OUTPUT_DIR)
	mkdir $(OUTPUT_DIR)
	perl ./generate.pl $(OUTPUT_DIR)

.PHONY: refresh
refresh:
	rm -f $(OUTPUT_DIR)/code.rs
	rm -f $(OUTPUT_DIR)/types.rs
	$(MAKE) $(OUTPUT_DIR)/code.rs $(OUTPUT_DIR)/types.rs

.PHONY: clean
clean:
	@true

=== proxmox/pbs-api-types/debian/changelog ===
rust-pbs-api-types (1.0.9-1) trixie; urgency=medium

  * add optional fallback variants to enums in public API. This is guarded
    behind the "enum-fallback" feature so that consumers of these types can
    avoid failing serialization and see what they missed while producers of
    this types do not need to care about this.

 -- Proxmox Support Team <support@proxmox.com>  Sun, 30 Nov 2025 22:07:22 +0100

rust-pbs-api-types (1.0.8-1) trixie; urgency=medium

  * datastore: add default-verification-{workers, readers} to tuning options.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 24 Nov 2025 14:02:20 +0100

rust-pbs-api-types (1.0.7-1) stable; urgency=medium

  * ClientRateLimitConfig: allow traffic-control rules to match users

 -- Proxmox Support Team <support@proxmox.com>  Fri, 21 Nov 2025 19:27:18 +0100

rust-pbs-api-types (1.0.6-1) stable; urgency=medium

  * add schema for {worker, read, verify}-threads.
  * jobs: add {read, verify}-threads to VerificationJobConfig.
  * use worker-threads schema for TapeBackupJobSetup.
  * add 'unmount-on-done' field to sync job config.

 -- Proxmox Support Team <support@proxmox.com>  Fri, 14 Nov 2025 22:28:34 +0100

rust-pbs-api-types (1.0.5-1) stable; urgency=medium

  * crypto: improve deserialization for Fingerprint with custom visitor

  * pbs-api-types: add NodeShellTicket

 -- Proxmox Support Team <support@proxmox.com>  Fri, 14 Nov 2025 11:41:14 +0100

rust-pbs-api-types (1.0.4-1) trixie; urgency=medium

  * update proxmox-schema to 5.0.0

 -- Proxmox Support Team <support@proxmox.com>  Thu, 04 Sep 2025 12:00:58 +0200

rust-pbs-api-types (1.0.3-1) trixie; urgency=medium

  * only include api-types from s3 client crate as dependency to avoid that
    our users need to pull in the whole tokio et al. stack, which is not
    possible for the WASM based Yew UIs.

  * move code over to common proxmox-network-api types.

 -- Proxmox Support Team <support@proxmox.com>  Wed, 06 Aug 2025 19:14:54 +0200

rust-pbs-api-types (1.0.2-1) trixie; urgency=medium

  * extend datastore config by optional backend property enum, for new S3
    backed datastores.

  * add new maintenance mode S3 refresh.

  * add run-on-mount flag to sync job config for removable datastores.

 -- Proxmox Support Team <support@proxmox.com>  Tue, 22 Jul 2025 21:45:43 +0200

rust-pbs-api-types (1.0.1-1) trixie; urgency=medium

  * change default notification mode to 'notification-system'

  * extend garbage collection status by cache stats

 -- Proxmox Support Team <support@proxmox.com>  Wed, 16 Jul 2025 00:54:42 +0200

rust-pbs-api-types (1.0.0-1) trixie; urgency=medium

  * re-build for Debian Trixie based releases.

 -- Proxmox Support Team <support@proxmox.com>  Fri, 30 May 2025 18:51:13 +0200

rust-pbs-api-types (0.2.2) bookworm; urgency=medium

  * add garbage collection atime safety check flag.
  * add option to set GC chunk cleanup atime cutoff.
  * fix #5379: add `default` field for all realm types.
  * sync: add sync encrypted/verified snapshots only flags.
  * add garbage collection cache capacity tuning option.

 -- Proxmox Support Team <support@proxmox.com>  Sat, 05 Apr 2025 17:22:09 +0200

rust-pbs-api-types (0.2.1) bookworm; urgency=medium

  * metrics: relax influx organization and bucket length
  * tape backup job: add worker threads option
  * user: add boolean-schema for regenerate-api-token flag

 -- Proxmox Support Team <support@proxmox.com>  Wed, 02 Apr 2025 15:34:49 +0200

rust-pbs-api-types (0.2.0) bookworm; urgency=medium

  * imported from proxmox-backup repository

 -- Proxmox Support Team <support@proxmox.com>  Wed, 22 Jan 2025 09:40:51 +0100

=== proxmox/pve-api-types/debian/changelog ===
rust-pve-api-types (8.1.4-1) trixie; urgency=medium

  * add node config get api call.
  * add cluster options api call.

 -- Proxmox Support Team <support@proxmox.com>  Tue, 02 Dec 2025 00:25:11 +0100

rust-pve-api-types (8.1.3-1) trixie; urgency=medium

  * enable enum-fallback for proxmox-apt-api-types for better backward
    compatibility.

  * don't mark URL parameters as optional.

  * handle fields named `ref`, which is a special keyword for rust, through
    using raw identifiers, similar to how we already handle `macro`.

  * percent-encode string parameters in the URL.

  * generate array objects. Previously the array objects had their *item* as
    schema, while we now generate the object schema by pointing to the item
    schemas for each field.

  * add method to get return schema of api.

  * fix #7080: pve-api-types: mark 'has-dbus-vmstate' optional.

  * generate ip-vrf / mac-vrf endpoints.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 01 Dec 2025 19:56:44 +0100

rust-pve-api-types (8.1.2-1) trixie; urgency=medium

  * add bindings for a PVE nodes APT package versions and APT package
    repository state.

  * add bindings for get/update firewall options endpoints.

  * add bindings for add list firewall rules endpoints.

 -- Proxmox Support Team <support@proxmox.com>  Thu, 27 Nov 2025 21:27:47 +0100

rust-pve-api-types (8.1.1-1) trixie; urgency=medium

  * derive Clone and PartialEq for LxcConfigNet.
  * rename QemuPendingConfigValue to PendingConfigValue as it can be used in a
    generic manner.
  * prepare API wrappers and types for LXC config, pending and move volume.
  * update API schema JSON file to current PVE 9.1 development state and
    refresh the generated types.

 -- Proxmox Support Team <support@proxmox.com>  Wed, 26 Nov 2025 21:49:06 +0100

rust-pve-api-types (8.1.0-1) trixie; urgency=medium

  * add FixedString type as a custom, immutable, string type, that main
    feature is being Copy, but is limited to up to 23 characters.

  * generate fallback variant for enums using the new FixedString type to
    store the name of such an unknown variant, allow more telling error
    messages or the use site to even decide that they can still work with that
    variant without an error in certain cases.
    This avoids that a use site breaks down completely if it gets send a
    unknown variant. The most common case this can happen is a newer backend
    for an older frontend (or vice versa), or special projects like PDM, which
    should be able to consume multiple product APIs over multiple versions.

  * regenerate types.

  * sdn: handle fallback variant.

 -- Proxmox Support Team <support@proxmox.com>  Thu, 13 Nov 2025 22:01:11 +0100

rust-pve-api-types (8.0.9-1) trixie; urgency=medium

  * update /cluster/resources endpoint as zone-type is now kebab-cased as
    well, instead of snake_cased.

 -- Proxmox Support Team <support@proxmox.com>  Thu, 13 Nov 2025 21:08:23 +0100

rust-pve-api-types (8.0.8-1) trixie; urgency=medium

  * add termproxy api call and types.
  * update /cluster/resources endpoint to incorporate new network,
    network-type, protocol and zone-type properties.
  * 

 -- Proxmox Support Team <support@proxmox.com>  Wed, 12 Nov 2025 21:57:26 +0100

rust-pve-api-types (8.0.7-1) trixie; urgency=medium

  * include latest pve-storage changes: add StorageInfoFormats
  * expose sync qemu_update_config

 -- Proxmox Support Team <support@proxmox.com>  Wed, 05 Nov 2025 12:10:55 +0100

rust-pve-api-types (8.0.6-1) trixie; urgency=medium

  * add qemu_cpu_capabilities api
  * add qemu_resize api
  * add qemu_move_disk api

 -- Proxmox Support Team <support@proxmox.com>  Tue, 04 Nov 2025 07:46:01 +0100

rust-pve-api-types (8.0.5-1) trixie; urgency=medium

  * implement array deduplication
  * schema2rust: handle missing properties hash in parameters
  * update json schema
  * generate arrays for types with '-list' format
  * add regex for storage and bridge pair

 -- Proxmox Support Team <support@proxmox.com>  Tue, 28 Oct 2025 13:35:41 +0100

rust-pve-api-types (8.0.4-1) trixie; urgency=medium

  * add qemu_update_config_async api

  * introduce regex-compilation tests

  * expose qemu pending api

 -- Proxmox Support Team <support@proxmox.com>  Thu, 16 Oct 2025 13:33:50 +0200

rust-pve-api-types (8.0.3-1) trixie; urgency=medium

  * derive Clone and PartialEq for ClusterResource

 -- Proxmox Support Team <support@proxmox.com>  Wed, 15 Oct 2025 10:09:11 +0200

rust-pve-api-types (8.0.2-1) trixie; urgency=medium

  * Include snapshot info in vm config return schema.
  * `cluster_metrics_export` now has an additional optional node_list
    parameter.

 -- Proxmox Support Team <support@proxmox.com>  Wed, 01 Oct 2025 10:42:09 +0200

rust-pve-api-types (8.0.1-1) trixie; urgency=medium

  * generate MAX constant for array types

 -- Proxmox Support Team <support@proxmox.com>  Mon, 29 Sep 2025 14:46:23 +0200

rust-pve-api-types (8.0.0-1) trixie; urgency=medium

  * initial packaging after having been split out from proxmox-api-types.git.
    This was used purely as git submodule before now.

 -- Proxmox Support Team <support@proxmox.com>  Mon, 15 Sep 2025 20:02:18 +0200

=== proxmox/pbs-api-types/debian/control ===
Source: rust-pbs-api-types
Section: rust
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-sequence-cargo
Build-Depends-Arch: cargo:native <!nocheck>,
 rustc:native <!nocheck>,
 libstd-rust-dev <!nocheck>,
 librust-anyhow-1+default-dev <!nocheck>,
 librust-const-format-0.2+default-dev <!nocheck>,
 librust-hex-0.4+default-dev <!nocheck>,
 librust-percent-encoding-2+default-dev (>= 2.1-~~) <!nocheck>,
 librust-proxmox-apt-api-types-2+default-dev (>= 2.0.4-~~) <!nocheck>,
 librust-proxmox-auth-api-1+api-types-dev (>= 1.0.5-~~) <!nocheck>,
 librust-proxmox-auth-api-1+default-dev (>= 1.0.5-~~) <!nocheck>,
 librust-proxmox-fixed-string-0.1+default-dev <!nocheck>,
 librust-proxmox-human-byte-1+default-dev <!nocheck>,
 librust-proxmox-lang-1+default-dev (>= 1.5-~~) <!nocheck>,
 librust-proxmox-s3-client-1+api-types-dev (>= 1.2-~~) <!nocheck>,
 librust-proxmox-s3-client-1+default-dev (>= 1.2-~~) <!nocheck>,
 librust-proxmox-schema-5+api-macro-dev (>= 5.0.1-~~) <!nocheck>,
 librust-proxmox-schema-5+default-dev (>= 5.0.1-~~) <!nocheck>,
 librust-proxmox-serde-1+default-dev <!nocheck>,
 librust-proxmox-serde-1+serde-json-dev <!nocheck>,
 librust-proxmox-time-2+default-dev (>= 2.1.0-~~) <!nocheck>,
 librust-proxmox-uuid-1+default-dev (>= 1.1.0-~~) <!nocheck>,
 librust-proxmox-uuid-1+serde-dev (>= 1.1.0-~~) <!nocheck>,
 librust-regex-1+default-dev (>= 1.5-~~) <!nocheck>,
 librust-serde-1+default-dev <!nocheck>,
 librust-serde-plain-1+default-dev <!nocheck>
Maintainer: Proxmox Support Team <support@proxmox.com>
Standards-Version: 4.7.2
Vcs-Git: git://git.proxmox.com/git/proxmox.git
Vcs-Browser: https://git.proxmox.com/?p=proxmox.git
X-Cargo-Crate: pbs-api-types

Package: librust-pbs-api-types-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-anyhow-1+default-dev,
 librust-const-format-0.2+default-dev,
 librust-hex-0.4+default-dev,
 librust-percent-encoding-2+default-dev (>= 2.1-~~),
 librust-proxmox-apt-api-types-2+default-dev (>= 2.0.4-~~),
 librust-proxmox-auth-api-1+api-types-dev (>= 1.0.5-~~),
 librust-proxmox-auth-api-1+default-dev (>= 1.0.5-~~),
 librust-proxmox-fixed-string-0.1+default-dev,
 librust-proxmox-human-byte-1+default-dev,
 librust-proxmox-lang-1+default-dev (>= 1.5-~~),
 librust-proxmox-s3-client-1+api-types-dev (>= 1.2-~~),
 librust-proxmox-s3-client-1+default-dev (>= 1.2-~~),
 librust-proxmox-schema-5+api-macro-dev (>= 5.0.1-~~),
 librust-proxmox-schema-5+default-dev (>= 5.0.1-~~),
 librust-proxmox-serde-1+default-dev,
 librust-proxmox-serde-1+serde-json-dev,
 librust-proxmox-time-2+default-dev (>= 2.1.0-~~),
 librust-proxmox-uuid-1+default-dev (>= 1.1.0-~~),
 librust-proxmox-uuid-1+serde-dev (>= 1.1.0-~~),
 librust-regex-1+default-dev (>= 1.5-~~),
 librust-serde-1+default-dev,
 librust-serde-plain-1+default-dev
Provides:
 librust-pbs-api-types+default-dev (= ${binary:Version}),
 librust-pbs-api-types+enum-fallback-dev (= ${binary:Version}),
 librust-pbs-api-types-1-dev (= ${binary:Version}),
 librust-pbs-api-types-1+default-dev (= ${binary:Version}),
 librust-pbs-api-types-1+enum-fallback-dev (= ${binary:Version}),
 librust-pbs-api-types-1.0-dev (= ${binary:Version}),
 librust-pbs-api-types-1.0+default-dev (= ${binary:Version}),
 librust-pbs-api-types-1.0+enum-fallback-dev (= ${binary:Version}),
 librust-pbs-api-types-1.0.9-dev (= ${binary:Version}),
 librust-pbs-api-types-1.0.9+default-dev (= ${binary:Version}),
 librust-pbs-api-types-1.0.9+enum-fallback-dev (= ${binary:Version})
Description: API types for Proxmox Backup Server - Rust source code
 Source code for Debianized Rust crate "pbs-api-types"

=== proxmox/pve-api-types/debian/control ===
Source: rust-pve-api-types
Section: rust
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-sequence-cargo
Build-Depends-Arch: cargo:native <!nocheck>,
 rustc:native <!nocheck>,
 libstd-rust-dev <!nocheck>,
 librust-anyhow-1+default-dev <!nocheck>,
 librust-async-trait-0.1+default-dev <!nocheck>,
 librust-proxmox-api-macro-1+default-dev (>= 1.4.3-~~) <!nocheck>,
 librust-proxmox-apt-api-types-2+default-dev (>= 2.0.4-~~) <!nocheck>,
 librust-proxmox-apt-api-types-2+enum-fallback-dev (>= 2.0.4-~~) <!nocheck>,
 librust-proxmox-fixed-string-0.1+default-dev <!nocheck>,
 librust-proxmox-schema-5+api-macro-dev (>= 5.0.1-~~) <!nocheck>,
 librust-proxmox-schema-5+api-types-dev (>= 5.0.1-~~) <!nocheck>,
 librust-proxmox-schema-5+default-dev (>= 5.0.1-~~) <!nocheck>,
 librust-proxmox-serde-1+default-dev <!nocheck>,
 librust-proxmox-serde-1+perl-dev <!nocheck>,
 librust-proxmox-serde-1+serde-json-dev <!nocheck>,
 librust-regex-1+default-dev (>= 1.5-~~) <!nocheck>,
 librust-serde-1+default-dev <!nocheck>,
 librust-serde-1+derive-dev <!nocheck>,
 librust-serde-json-1+default-dev <!nocheck>,
 librust-serde-plain-1+default-dev <!nocheck>
Maintainer: Proxmox Support Team <support@proxmox.com>
Standards-Version: 4.7.2
Vcs-Git: git://git.proxmox.com/git/proxmox.git
Vcs-Browser: https://git.proxmox.com/?p=proxmox.git
Homepage: https://git.proxmox.com/?p=proxmox.git
X-Cargo-Crate: pve-api-types

Package: librust-pve-api-types-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-anyhow-1+default-dev,
 librust-async-trait-0.1+default-dev,
 librust-proxmox-api-macro-1+default-dev (>= 1.4.3-~~),
 librust-proxmox-apt-api-types-2+default-dev (>= 2.0.4-~~),
 librust-proxmox-apt-api-types-2+enum-fallback-dev (>= 2.0.4-~~),
 librust-proxmox-fixed-string-0.1+default-dev,
 librust-proxmox-schema-5+api-macro-dev (>= 5.0.1-~~),
 librust-proxmox-schema-5+api-types-dev (>= 5.0.1-~~),
 librust-proxmox-schema-5+default-dev (>= 5.0.1-~~),
 librust-proxmox-serde-1+default-dev,
 librust-proxmox-serde-1+perl-dev,
 librust-proxmox-serde-1+serde-json-dev,
 librust-regex-1+default-dev (>= 1.5-~~),
 librust-serde-1+default-dev,
 librust-serde-1+derive-dev,
 librust-serde-json-1+default-dev,
 librust-serde-plain-1+default-dev
Suggests:
 librust-pve-api-types+client-dev (= ${binary:Version}),
 librust-pve-api-types+client-util-dev (= ${binary:Version})
Provides:
 librust-pve-api-types+default-dev (= ${binary:Version}),
 librust-pve-api-types-8-dev (= ${binary:Version}),
 librust-pve-api-types-8+default-dev (= ${binary:Version}),
 librust-pve-api-types-8.1-dev (= ${binary:Version}),
 librust-pve-api-types-8.1+default-dev (= ${binary:Version}),
 librust-pve-api-types-8.1.4-dev (= ${binary:Version}),
 librust-pve-api-types-8.1.4+default-dev (= ${binary:Version})
Description: Proxmox VE API types - Rust source code
 Source code for Debianized Rust crate "pve-api-types"

Package: librust-pve-api-types+client-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-pve-api-types-dev (= ${binary:Version}),
 librust-pve-api-types+client-util-dev (= ${binary:Version}),
 librust-proxmox-client-1+default-dev,
 librust-proxmox-client-1+perl-api-path-builder-dev
Provides:
 librust-pve-api-types-8+client-dev (= ${binary:Version}),
 librust-pve-api-types-8.1+client-dev (= ${binary:Version}),
 librust-pve-api-types-8.1.4+client-dev (= ${binary:Version})
Description: Proxmox VE API types - feature "client"
 This metapackage enables feature "client" for the Rust pve-api-types crate, by
 pulling in any additional dependencies needed by that feature.

Package: librust-pve-api-types+client-util-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-pve-api-types-dev (= ${binary:Version}),
 librust-percent-encoding-2+default-dev (>= 2.1-~~)
Provides:
 librust-pve-api-types-8+client-util-dev (= ${binary:Version}),
 librust-pve-api-types-8.1+client-util-dev (= ${binary:Version}),
 librust-pve-api-types-8.1.4+client-util-dev (= ${binary:Version})
Description: Proxmox VE API types - feature "client-util"
 This metapackage enables feature "client-util" for the Rust pve-api-types
 crate, by pulling in any additional dependencies needed by that feature.
